module Gitmain
  class Commit
    attr_reader :id, :repository

    def initialize(repository, id)
      raise ArgumentError, 'provide a valid repository' unless repository.kind_of?(Gitmain::Repository)
      raise ArgumentError, 'provide a valid commit id' unless id.to_s.match(/\A[0-9a-f]{40}\z/)
      @repository = repository
      @id = id
    end

    def author_email
      _commit&.author[:email]
    end

    def author_name
      _commit&.author[:name]
    end

    def message
      _commit&.message
    end

    def parent_ids
      _commit&.parent_ids
    end

    def time
      _commit&.time
    end

    private

    def _commit
      @_commit ||= repository.rugged(id)
    end
  end
end
